# Sound

Playing sound is supported in Hology Engine using ThreeJS. See their documentation for more detail on how to use [Audio](https://threejs.org/docs/#api/en/audio/Audio) and [Positional Audio](https://threejs.org/docs/#api/en/audio/PositionalAudio).

## Playing sound

In the code below we can see how we can utilize Audio instances, load audio files and play sound.

The following numbered points refer to different parts of the code below.

1. Each sound that needs to be played needs its own instance of Audio. You can reuse audio instances but to play multiple sounds at the same time, you will need separate instances.
2. Load an audio file directly from the public directory. These don't have to be imported in the editor before.
3. To use the loaded audio, use the `setBuffer` function. You can also adjust the volume and other settings which you can read more about in the [ThreeJS docs](https://threejs.org/docs/#api/en/audio/Audio).
4. Play the sound. If the sound is already playing however, you need to stop it first.

```typescript
import { inject, Service, World, GameInstance, ViewController, AssetLoader } from '@hology/core/gameplay';
import * as THREE from 'three';

@Service()
class Game extends GameInstance {
  private world = inject(World)
  private view = inject(ViewController)
  private assetLoader = inject(AssetLoader)

  // 1
  private sound = new THREE.Audio(this.view.audioListener);

  async onStart() {    
    // 2
    const buffer = await this.assetLoader.getAudioAtPath('data/asset-resources/impactWood_heavy_001.ogg')
    // 3
    this.sound.setBuffer(buffer).setVolume(0.5)
  }

  playSound() {
    if (this.sound.isPlaying) {
      this.sound.stop()
    }
    // 4
    this.sound.play();
  }
}

export default Game
```

You can see a complete example for playing sound and run it locally to it out yourself here.

{% embed url="<https://github.com/hologyengine/audio-tutorial/tree/main>" %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hology.app/gameplay/sound.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
